EX(1)

NAME
ex, edit - text editor

SYNOPSIS
ex [ - ] [ -v ] [ -t tag ] [ -r ] [ +command ] [ -l ] name ...
edit [ ex options ]

DESCRIPTION
Ex is the root of a family of editors: edit, ex and vi. Ex is a superset of ed, with the most notable extension being a display editing facility. Display based editing is the focus of vi.

If you have not used ed, or are a casual user, you will find that the editor edit is convenient for you. It avoids some of the complexities of ex used mostly by systems programmers and persons very familiar with ed.

If you have a CRT terminal, you may wish to use a display based editor; in this case see vi(1), which is a command which focuses on the display editing portion of ex.

OPTIONS

-   Suppress all interactive feedback to the user (useful for processing ex scripts in shell files).

-l  Set up for editing LISP programs.

-r  Recover the indicated filenames after a system crash.

-R  Read only. Do not overwrite the original file.

-v  Start up in display editing state using vi. You can achieve the same effect by simply typing the vi command itself.

-t tag
    Edit the file containing the tag tag. A tags database must first be created using the ctags(1) command.

-wn Set the default window (number of lines on your terminal) to n

+command
    Start the editing session by executing command.

DOCUMENTATION
The document Edit: A tutorial (USD:14) provides a comprehensive introduction to edit assuming no previous knowledge of computers or the UNIX system.

The Ex Reference Manual - Version 3.7 (USD:16) is a comprehensive and complete manual for the command mode features of ex, but you cannot learn to use the editor by reading it. For an introduction to more advanced forms of editing using the command mode of ex see the editing documents written by Brian Kernighan for the editor ed; the material in the introductory and advanced documents works also with ex.

An Introduction to Display Editing with Vi (USD:15) introduces the display editor vi and provides reference material on vi. In addition, the Vi Quick Reference card summarizes the commands of vi in a useful, functional way, and is useful with the Introduction.

FILES
/usr/lib/ex?.?strings    error messages
/usr/lib/ex?.?recover    recover command
/usr/lib/ex?.?preserve    preserve command
/etc/termcap    describes capabilities of terminals
~/.exrc    editor startup file
/tmp/Exnnnnn    editor temporary
/tmp/Rxnnnnn    named buffer temporary
/var/preserve    preservation directory

SEE ALSO
awk(1), ed(1), grep(1), sed(1), grep(1), vi(1), termcap(5), environ(7)

AUTHOR
Originally written by William Joy
Mark Horton has maintained the editor since version 2.7, adding macros, support for many unusual terminals, and other features such as word abbreviation mode.

BUGS
The undo command causes all marks to be lost on lines changed and then restored if the marked lines were changed.

Undo never clears the buffer modified condition.

The z command prints a number of logical rather than physical lines. More than a screen full of output may result if long lines are present.

File input/output errors don't print a name if the command line `-' option is used.

There is no easy way to do a single scan ignoring case.

The editor does not warn if text is placed in named buffers and not used before exiting the editor.

Null characters are discarded in input files, and cannot appear in resultant files.